-- Generated from:  "@(#) src/ll/db/gen/mysql/ll_cfg_scheduler_tables.sql, ll.db.gen, ll_rrnep2, rrnep2s015a 1.36 2/6/13";
-- IBM_PROLOG_BEGIN_TAG 
-- This is an automatically generated prolog. 
--  
--  
--  
-- Licensed Materials - Property of IBM 
--  
-- Restricted Materials of IBM 
--  
-- (C) COPYRIGHT International Business Machines Corp. 2009,2013 
-- All Rights Reserved 
--  
-- US Government Users Restricted Rights - Use, duplication or 
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
--  
-- IBM_PROLOG_END_TAG 
CREATE TABLE TLLS_CFGUser (
	userID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL, 
	account VARCHAR(80), 
	default_class VARCHAR(800), 
	default_group VARCHAR(80), 
	default_interactive_class VARCHAR(80), 
	env_copy CHAR(6), 
	fair_shares INTEGER, 
	max_node INTEGER, 
	max_reservation_duration INTEGER, 
	max_reservation_expiration INTEGER, 
	max_reservations INTEGER, 
	max_total_tasks INTEGER, 
	maxidle INTEGER, 
	maxjobs INTEGER, 
	maxqueued INTEGER, 
	priority INTEGER, 
	total_tasks INTEGER, 
	reservation_type CHAR(16), 
	cpu_frequency_permitted CHAR(5), 
	energy_data_list VARCHAR(1024), 
	UNIQUE (clusterID, name),
	PRIMARY KEY (userID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGGroup ( 
	groupID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER,
	name VARCHAR(80) NOT NULL, 
	admin_list VARCHAR(80), 
	env_copy CHAR(6), 
	fair_shares INTEGER, 
	max_node INTEGER, 
	max_reservation_duration INTEGER, 
	max_reservation_expiration INTEGER, 
	max_reservations INTEGER, 
	max_total_tasks INTEGER, 
	maxidle INTEGER, 
	maxjobs INTEGER, 
	maxqueued INTEGER, 
	priority INTEGER, 
	total_tasks INTEGER, 
	userListType CHAR(1),   -- E for exclude, I for include 
               
               
	reservation_type CHAR(16), 
	cpu_frequency_permitted CHAR(5), 
	energy_data_list VARCHAR(1024), 
	UNIQUE (name),
	PRIMARY KEY (groupID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGGroupUsers (
	groupID INTEGER NOT NULL,
	users VARCHAR(80) NOT NULL,
	PRIMARY KEY (groupID, users),
	FOREIGN KEY (groupID) REFERENCES TLLS_CFGGroup (groupID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClass (
	classID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,  
	admin_list VARCHAR(255),  
	allow_scale_across_jobs CHAR(5),  
	ckpt_dir VARCHAR(1024),   
	class_comment VARCHAR(200),  
	env_copy CHAR(6),  
	master_node_requirement CHAR(5),  
	max_node INTEGER,  
	max_protocol_instances INTEGER,  
	max_top_dogs INTEGER,  
	max_total_tasks INTEGER,  
	maxjobs INTEGER,  
	nice INTEGER,  
	priority INTEGER,  
	smt CHAR(5),  
	striping_with_minimum_networks CHAR(5),  
	total_tasks INTEGER,  
	bgListType CHAR(1),  	-- E for exclude, I for include
               
               
	groupListType CHAR(1),  -- E for exclude, I for include
               
               
	userListType CHAR(1),   -- E for exclude, I for include
               
               
	provision_job CHAR(5), 
	restart VARCHAR(3), 
	collective_groups INTEGER,  
	imm_send_buffers INTEGER,  
	node_topology INTEGER,  
	endpoints INTEGER,  
	UNIQUE (clusterID, name),
	PRIMARY KEY (classID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassLimits (
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	hardlimit VARCHAR(80),
	softlimit VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassDefaultResources ( 
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassDefaultNodeResources ( 
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassMaxResources ( 
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassMaxNodeResources ( 
	classID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (classID, name),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassBG (
	classID INTEGER NOT NULL,
	bg VARCHAR(80) NOT NULL,
	PRIMARY KEY (classID, bg),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassGroups (
	classID INTEGER NOT NULL,
	groups VARCHAR(80) NOT NULL,
	PRIMARY KEY (classID, groups), 
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassUsers (
	classID INTEGER NOT NULL,
	users VARCHAR(80) NOT NULL,
	PRIMARY KEY (classID, users),  
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGClassUser (
	classID INTEGER NOT NULL,
	userName VARCHAR(80) NOT NULL, 
	max_total_tasks INTEGER, 
	maxidle INTEGER, 
	maxjobs INTEGER, 
	maxqueued INTEGER, 
	PRIMARY KEY (classID, userName),
	FOREIGN KEY (classID) REFERENCES TLLS_CFGClass (classID) ON DELETE CASCADE
) in LLTBS8K;
-- ll_sch_config_machine_keywords  
CREATE TABLE TLLS_CFGPreempt (
	nodeID INTEGER NOT NULL,
	preemption_support CHAR(10), 
	default_preempt_method CHAR(2), 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGPreemptClass ( 
	preemptID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER NOT NULL,
	incoming_class VARCHAR(80) NOT NULL,
	all_or_enough CHAR(6) NOT NULL,
	method CHAR(2) NOT NULL,
	PRIMARY KEY (preemptID),
	UNIQUE(clusterID, incoming_class, all_or_enough, method),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGPreemptClassOutgoing (
	preemptID INTEGER NOT NULL,
	outgoing_class VARCHAR(80) NOT NULL,
	PRIMARY KEY (preemptID, outgoing_class),
	FOREIGN KEY (preemptID) REFERENCES TLLS_CFGPreemptClass (preemptID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGPreemptStartClass ( 
	startID INTEGER GENERATED ALWAYS AS IDENTITY (START WITH 1, INCREMENT BY 1, NO CACHE),
	clusterID INTEGER NOT NULL,
	incoming_class VARCHAR(80) NOT NULL,
	PRIMARY KEY (startID),
	UNIQUE (clusterID, incoming_class),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGPreemptStartClassRunningTasks (
	startID INTEGER NOT NULL,
	running_class VARCHAR(80) NOT NULL,
	number_of_tasks integer,
	PRIMARY KEY (startID, running_class),
	FOREIGN KEY (startID) REFERENCES TLLS_CFGPreemptStartClass (startID) ON DELETE CASCADE
) in LLTBS8K;
-- ll_sch_config_cluster_keywords
CREATE TABLE TLLS_CFGCentralManager (
	nodeID INTEGER NOT NULL,
	negotiator VARCHAR(1024), 
	trunc_negotiator_log_on_open CHAR(5), 
	negotiator_log VARCHAR(1024), 
	max_negotiator_log BIGINT, 
	max_negotiator_log_buffer BIGINT,
	negotiator_debug VARCHAR(255), 
	negotiator_debug_buffer VARCHAR(255),
	negotiator_coredump_dir VARCHAR(1024), 
	negotiator_cycle_delay INTEGER, 
	negotiator_cycle_time_limit INTEGER, 
	negotiator_interval INTEGER, 
	negotiator_loadavg_increment DOUBLE, 
	negotiator_recalculate_sysprio_interval INTEGER, 
	negotiator_reject_defer INTEGER, 
	negotiator_rescan_queue INTEGER, 
	negotiator_remove_completed INTEGER, 
	negotiator_parallel_defer INTEGER, 
	negotiator_parallel_hold INTEGER, 
	negotiator_stream_port INTEGER, 
	cm_collector_port INTEGER, 
	cm_check_userid CHAR(5), 
	percent_of_s3_required INTEGER, 
	max_wait_time_for_top_dogs INTEGER, 
	top_dogs_dispatched_before_s3 INTEGER, 
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGScheduler (
	clusterID INTEGER NOT NULL,
	action_on_max_reject CHAR(7), 
	max_job_reject INTEGER, 
	enforce_resource_submission CHAR(5), 
	machprio VARCHAR(256), 
	max_top_dogs INTEGER, 
	schedd_submit_affinity CHAR(5), 
	sysprio VARCHAR(256), 
	sysprio_threshold_to_ignore_step INTEGER, 
	vm_image_algorithm CHAR(40), 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGScheduleByResources ( 
	clusterID INTEGER NOT NULL,
	resource VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, resource),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGReservation (
	clusterID INTEGER NOT NULL,
	max_reservations INTEGER, 
	reservation_can_be_exceeded CHAR(5), 
	reservation_min_advance_time INTEGER, 
	reservation_priority CHAR(4), 
	reservation_setup_time INTEGER, 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGMCluster (
	clusterID INTEGER NOT NULL,
	cluster_metric VARCHAR(1024), 
	cluster_remote_job_filter VARCHAR(1024), 
	cluster_user_mapper VARCHAR(1024), 
	scale_across_scheduling_timeout INTEGER, 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGBG ( 
	clusterID INTEGER NOT NULL,
	bg_allow_ll_jobs_only CHAR(5), 
	bg_cache_blocks CHAR(5), 
	bg_enabled CHAR(5), 
	bg_min_block_size INTEGER, 
	bg_enable_passthrough CHAR(5), 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGFairShare ( 
	clusterID INTEGER NOT NULL,
	fair_share_interval INTEGER, 
	fair_share_total_shares INTEGER, 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
CREATE TABLE TLLS_CFGDstg (
	clusterID INTEGER NOT NULL,
	dstg_min_scheduling_interval INTEGER, 
	dstg_time CHAR(12), 
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)  ON DELETE CASCADE
) in LLTBS8K;
