-- sccs_id = "@(#) src/ll/db/gen/mysql/ll_cfg_resmgr_tables.sql, ll.db.gen, ll_rrnep2, rrnep2s008b 1.33 6/14/12 11:49:36";
-- IBM_PROLOG_BEGIN_TAG 
-- This is an automatically generated prolog. 
--  
--  
--  
-- Licensed Materials - Property of IBM 
--  
-- Restricted Materials of IBM 
--  
-- (C) COPYRIGHT International Business Machines Corp. 2009,2012 
-- All Rights Reserved 
--  
-- US Government Users Restricted Rights - Use, duplication or 
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
--  
-- IBM_PROLOG_END_TAG 

CREATE TABLE TLLR_CFGRegion (
	regionID INTEGER AUTO_INCREMENT,
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL, -- %st=region %kw=label
	region_mgr_list VARCHAR(2560), -- %st=region %kw=region_mgr_list
	PRIMARY KEY (regionID),
	UNIQUE (clusterID, name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
)  ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMCluster (
	clusterID INTEGER NOT NULL,
	allow_scale_across_jobs CHAR(5), -- %st=cluster %kw=allow_scale_across_jobs
	inbound_schedd_port INTEGER, -- %st=cluster %kw=inbound_schedd_port
	local_flag CHAR(5),  -- %st=cluster %kw=local
	main_scale_across_cluster CHAR(5),  -- %st=cluster %kw=main_scale_across_cluster
	multicluster_security CHAR(3), -- %st=cluster %st=cluster %kw=multicluster_security
	secure_schedd_port INTEGER, -- %st=cluster %kw=secure_schedd_port
	ssl_cipher_list VARCHAR(80), -- %st=cluster %kw=ssl_cipher_list
	-- For ListTypes, E for exclude, I for include
	classListType CHAR(1), -- %st=cluster %kw=include_classes
	                       -- %st=cluster %kw=exclude_classes
	groupListType CHAR(1), -- %st=cluster %kw=include_groups
                               -- %st=cluster %kw=exclude_groups
	userListType CHAR(1),  -- %st=cluster %kw=include_users
                               -- %st=cluster %kw=exclude_users
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
)  ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMClusterClasses (
	clusterID INTEGER NOT NULL,
	class_name VARCHAR(80) BINARY NOT NULL, 
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, class_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMClusterGroups (
	clusterID INTEGER NOT NULL,
	group_name VARCHAR(80) BINARY NOT NULL,	
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, group_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMClusterUsers (
	clusterID INTEGER NOT NULL,
	user_name VARCHAR(80) BINARY NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, user_name, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMClusterInboundHosts ( -- %st=cluster %kw=inbound_hosts
	clusterID INTEGER NOT NULL,
	hostname VARCHAR(256) NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, hostname, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMClusterOutboundHosts ( -- %st=cluster %kw=outbound_hosts
	clusterID INTEGER NOT NULL,
	hostname VARCHAR(256) NOT NULL,
	cluster_name VARCHAR(80) NOT NULL,
	PRIMARY KEY (clusterID, hostname, cluster_name),
	FOREIGN KEY (clusterID) REFERENCES TLLR_CFGMCluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachine (
	nodeID INTEGER NOT NULL,
	name VARCHAR(256), -- %st=machine %kw=label
	adapter_list VARCHAR(80),-- %st=machine %kw=adapter_list
	alias VARCHAR(256),-- %st=machine %kw=alias
	-- central_manager replaced by central_manager_list in TLLS_CFGCentralManager
	cpu_speed_scale	CHAR(5),-- %st=machine %kw=cpu_speed_scale
	feature VARCHAR(1024),-- %st=machine %kw=feature
	pool_list VARCHAR(80),-- %st=machine %kw=pool_list
	prestarted_starters INTEGER,-- %st=machine %kw=prestarted_starters
	regionID INTEGER,
         -- on this line so not associated with regionID %st=machine %kw=region
	schedd_fenced CHAR(5), -- %st=machine %kw=schedd_fenced
	schedd_host CHAR(5), -- %st=machine %kw=schedd_host
	speed DOUBLE, -- %st=machine %kw=speed
	submit_only CHAR(5), -- %st=machine %kw=submit_only
	schedd_runs_here CHAR(5), -- %st=machine %kw=schedd_runs_here
	startd_runs_here CHAR(5), -- %st=machine %kw=startd_runs_here
	arch CHAR(20), -- %st=machine %kw=arch
	opsys CHAR(20), -- %st=machine %kw=opsys
	machine_mode CHAR(12), -- %st=machine %kw=machine_mode
	master_node_exclusive CHAR(5), -- %st=machine %kw=master_node_exclusive
	max_jobs_scheduled INTEGER, -- %st=machine %kw=max_jobs_scheduled
	reservation_permitted CHAR(5), -- %st=machine %kw=reservation_permitted
	dstg_max_starters INTEGER, -- %st=machine %kw=dstg_max_starters
	max_starters INTEGER, -- %st=machine %kw=max_starters
	provision_node CHAR(6), -- %st=machine %kw=provision_node
	island VARCHAR(256), -- %st=machine %kw=island
	power_management_policy VARCHAR(256), -- %st=machine %kw=power_management_policy
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE,
	FOREIGN KEY (regionID) REFERENCES TLLR_CFGRegion (regionID) ON DELETE SET NULL
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineClass ( -- %st=machine %kw=class
	nodeID INTEGER NOT NULL,
	class_name VARCHAR(80) BINARY NOT NULL,
	class_count INTEGER,
	PRIMARY KEY (nodeID, class_name),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineResources ( -- %st=machine %kw=resources
	nodeID INTEGER NOT NULL,
	resource_name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (nodeID, resource_name),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineNameServer ( -- %st=machine %kw=name_server
	nodeID INTEGER NOT NULL,
	name_server CHAR(5) NOT NULL,
	PRIMARY KEY (nodeID, name_server),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineGroup (
	mgID INTEGER NOT NULL,
	adapter_list VARCHAR(256), -- %st=machine_group %kw=adapter_list
	cpu_speed_scale CHAR(5), -- %st=machine_group %kw=cpu_speed_scale
	feature VARCHAR(1024), -- %st=machine_group %kw=feature
	pool_list VARCHAR(80), -- %st=machine_group %kw=pool_list
	prestarted_starters INTEGER, -- %st=machine_group %kw=prestarted_starters
	regionID INTEGER, 
         -- on this line so not associated with regionID %st=machine_group %kw=region
	schedd_fenced CHAR(5), -- %st=machine_group %kw=schedd_fenced
	schedd_host CHAR(5), -- %st=machine_group %kw=schedd_host
	schedd_runs_here CHAR(5), -- %st=machine_group %kw=schedd_runs_here
	speed DOUBLE, -- %st=machine_group %kw=speed
	startd_runs_here CHAR(5), -- %st=machine_group %kw=startd_runs_here
	submit_only CHAR(5), -- %st=machine_group %kw=submit_only
	machine_mode CHAR(12), -- %st=machine_group %kw=machine_mode
	master_node_exclusive CHAR(5), -- %st=machine_group %kw=master_node_exclusive
	max_jobs_scheduled INTEGER, -- %st=machine_group %kw=max_jobs_scheduled
	reservation_permitted CHAR(5), -- %st=machine_group %kw=reservation_permitted
	dstg_max_starters INTEGER, -- %st=machine_group %kw=dstg_max_starters
	max_starters INTEGER, -- %st=machine_group %kw=max_starters
	provision_node CHAR(6), -- %st=machine_group %kw=provision_node
	island VARCHAR(256), -- %st=machine_group %kw=island
	power_management_policy VARCHAR(256), -- %st=machine_group %kw=power_management_policy
	PRIMARY KEY (mgID),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE,
	FOREIGN KEY (regionID) REFERENCES TLLR_CFGRegion (regionID) ON DELETE SET NULL
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineGroupMachineList ( -- %st=machine_group %kw=machine_list
	mgID INTEGER NOT NULL,
	machines VARCHAR(256),
	-- PRIMARY KEY (mgID, machines),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineGroupClass ( -- %st=machine_group %kw=class
	mgID INTEGER NOT NULL,
	class_name VARCHAR(80) BINARY NOT NULL,
	class_count INTEGER,
	PRIMARY KEY (mgID, class_name),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineGroupResources ( -- %st=machine_group %kw=resources
	mgID INTEGER NOT NULL,
	resource_name VARCHAR(80) NOT NULL,
	resource_count VARCHAR(80),
	PRIMARY KEY (mgID, resource_name),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGMachineGroupNameServer ( -- %st=machine_group %kw=name_server
	mgID INTEGER NOT NULL,
	name_server CHAR(5) NOT NULL,
	PRIMARY KEY (mgID, name_server),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE CASCADE
) ENGINE = InnoDB;


-- ll_res_config_machine_keywords

CREATE TABLE TLLR_CFGMaster (
	nodeID INTEGER NOT NULL,
	master VARCHAR(1024), -- %kw=master
	trunc_master_log_on_open CHAR(5), -- %kw=trunc_master_log_on_open
	master_coredump_dir VARCHAR(1024), -- %kw=master_coredump_dir
	master_log VARCHAR(1024), -- %kw=master_log
	master_debug VARCHAR(255), -- %kw=master_debug
	master_debug_buffer VARCHAR(255), 
	max_master_log BIGINT, -- %kw=max_master_log
	max_master_log_buffer BIGINT,
	master_dgram_port INTEGER, -- %kw=master_dgram_port
	master_stream_port INTEGER, -- %kw=master_stream_port
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGKbdd (
	nodeID INTEGER NOT NULL,
	kbdd VARCHAR(1024), -- %kw=kbdd
	trunc_kbdd_log_on_open CHAR(5), -- %kw=trunc_kbdd_log_on_open
	kbdd_coredump_dir VARCHAR(1024), -- %kw=kbdd_coredump_dir
	kbdd_log VARCHAR(1024), -- %kw=kbdd_log
	max_kbdd_log BIGINT, -- %kw=max_kbdd_log
	max_kbdd_log_buffer BIGINT,
	kbdd_debug VARCHAR(255), -- %kw=kbdd_debug
	kbdd_debug_buffer VARCHAR(255),
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGRegionMgr (
	nodeID INTEGER NOT NULL,
	region_mgr VARCHAR(1024), -- %kw=region_mgr
	adapter_heartbeat_retries INTEGER, -- %kw=adapter_heartbeat_retries
	adapter_heartbeat_interval INTEGER, -- %kw=adapter_heartbeat_interval
	adapter_heartbeat_port INTEGER, -- %kw=adapter_heartbeat_port
	trunc_region_mgr_log_on_open CHAR(5), -- %kw=trunc_region_mgr_log_on_open
	region_mgr_log VARCHAR(1024), -- %kw=region_mgr_log
	max_region_mgr_log BIGINT, -- %kw=max_region_mgr_log
	max_region_mgr_log_buffer BIGINT,
	region_mgr_debug VARCHAR(255), -- %kw=region_mgr_debug
	region_mgr_debug_buffer VARCHAR(255),
	region_mgr_coredump_dir VARCHAR(1024), -- %kw=region_mgr_coredump_dir
	region_mgr_stream_port INTEGER, -- %kw=region_mgr_stream_port
	region_mgr_dgram_port INTEGER, -- %kw=region_mgr_dgram_port
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;

CREATE TABLE TLLR_CFGResourceMgr (
	nodeID INTEGER NOT NULL,
	resource_mgr CHAR(80), -- %kw=resource_mgr
	trunc_resource_mgr_log_on_open CHAR(5), -- %kw=trunc_resource_mgr_log_on_open
	resource_mgr_log VARCHAR(1024), -- %kw=resource_mgr_log
	max_resource_mgr_log BIGINT, -- %kw=max_resource_mgr_log
	max_resource_mgr_log_buffer BIGINT,
	resource_mgr_debug VARCHAR(255), -- %kw=resource_mgr_debug
	resource_mgr_debug_buffer VARCHAR(255),
	resource_mgr_coredump_dir VARCHAR(1024), -- %kw=resource_mgr_coredump_dir
	resource_mgr_stream_port INTEGER, -- %kw=resource_mgr_stream_port
	resource_mgr_dgram_port INTEGER, -- %kw=resource_mgr_dgram_port
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGStartd (
	nodeID INTEGER NOT NULL,
	custom_metric INTEGER, -- %kw=custom_metric
	custom_metric_command VARCHAR(1024), -- %kw=custom_metric_command
	startd VARCHAR(1024), -- %kw=startd
	startd_log VARCHAR(1024), -- %kw=startd_log
	startd_coredump_dir VARCHAR(1024), -- %kw=startd_coredump_dir
	trunc_startd_log_on_open CHAR(5), -- %kw=trunc_startd_log_on_open
	max_startd_log BIGINT, -- %kw=max_startd_log
	max_startd_log_buffer BIGINT,
	startd_debug VARCHAR(255), -- %kw=startd_debug
	startd_debug_buffer VARCHAR(255),
	startd_dgram_port INTEGER, -- %kw=startd_dgram_port
	startd_stream_port INTEGER, -- %kw=startd_stream_port
	alloc_exclusive_cpu_per_job CHAR(8), -- %kw=alloc_exclusive_cpu_per_job
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGStarter (
	nodeID INTEGER NOT NULL,
	starter VARCHAR(1024), -- %kw=starter
	trunc_starter_log_on_open CHAR(5), -- %kw=trunc_starter_log_on_open
	starter_coredump_dir VARCHAR(1024), -- %kw=starter_coredump_dir
	starter_log VARCHAR(1024), -- %kw=starter_log
	starter_debug VARCHAR(255), -- %kw=starter_debug
	starter_debug_buffer VARCHAR(255),
	max_starter_log BIGINT, -- %kw=max_starter_log
	max_starter_log_buffer BIGINT,
	sshd_ports VARCHAR(256), -- %kw=sshd_ports
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGSchedd (
	nodeID INTEGER NOT NULL,
	schedd VARCHAR(1024), -- %kw=schedd
	trunc_schedd_log_on_open CHAR(5), -- %kw=trunc_schedd_log_on_open
	schedd_log VARCHAR(1024), -- %kw=schedd_log
	max_schedd_log BIGINT, -- %kw=max_schedd_log
	max_schedd_log_buffer BIGINT,
	schedd_debug VARCHAR(255), -- %kw=schedd_debug
	schedd_debug_buffer VARCHAR(255),
	schedd_coredump_dir VARCHAR(1024), -- %kw=schedd_coredump_dir
	schedd_stream_port INTEGER, -- %kw=schedd_stream_port
	schedd_status_port INTEGER, -- %kw=schedd_status_port
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGVars (
	clusterID INTEGER NOT NULL,
	var_name VARCHAR(80) NOT NULL,
	var_value VARCHAR(1024),
	PRIMARY KEY (clusterID, var_name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


-- ll_res_config_cluster_keywords.sql

CREATE TABLE TLLR_CFGAcct (
	nodeID INTEGER NOT NULL,
	acct_validation VARCHAR(1024), -- %kw=acct_validation
	global_history VARCHAR(1024), -- %kw=global_history
	history VARCHAR(1024), -- %kw=history
	history_permission CHAR(10), -- %kw=history_permission
	reservation_history VARCHAR(1024), -- %kw=reservation_history
	job_acct_q_policy INTEGER, -- %kw=job_acct_q_policy
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGAcctFlags (  -- %kw=acct
	nodeID INTEGER NOT NULL,
	acct_flag CHAR(10) NOT NULL,
	PRIMARY KEY(nodeID, acct_flag),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGWLM (
	nodeID INTEGER NOT NULL,
	enforce_resource_memory CHAR(5), -- %kw=enforce_resource_memory
	enforce_resource_policy CHAR(6), -- %kw=enforce_resource_policy
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGWLMUsage ( -- %kw=enforce_resource_usage
	nodeID INTEGER NOT NULL,
	enforce_resource_usage CHAR(30) NOT NULL,
	PRIMARY KEY (nodeID, enforce_resource_usage),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGSwitch (
	nodeID INTEGER NOT NULL,
	action_on_switch_table_error VARCHAR(1024), -- %kw=action_on_switch_table_error
	drain_on_switch_table_error CHAR(5), -- %kw=drain_on_switch_table_error
	resume_on_switch_table_error_clear CHAR(5), -- %kw=resume_on_switch_table_error_clear
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGFileSysMon ( 
	fsID INTEGER AUTO_INCREMENT,
	nodeID INTEGER NOT NULL,
	fs_interval INTEGER, -- %kw=fs_interval
	PRIMARY KEY (fsID),
	UNIQUE (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


-- TODO - ll_res_tables.sql -  the following keywords are stored in TLLR_CFGFileSysMonThresholds, need to have some validation to the name 
-- fs_notify VARCHAR(80),
-- fs_suspend VARCHAR(80),
-- fs_terminate VARCHAR(80),
-- inode_notify VARCHAR(80), 
-- inode_suspend VARCHAR(80),
-- inode_terminate VARCHAR(80),
CREATE TABLE TLLR_CFGFileSysMonThresholds ( 
-- %kw=fs_notify
-- %kw=fs_suspend
-- %kw=fs_terminate
-- %kw=inode_notify
-- %kw=inode_suspend
-- %kw=inode_terminate
	fsID INTEGER NOT NULL,
	name CHAR(16) NOT NULL,
	lower_threshold VARCHAR(80),
	upper_threshold VARCHAR(80),
	PRIMARY KEY (fsID, name),
	FOREIGN KEY (fsID) REFERENCES TLLR_CFGFileSysMon (fsID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGCkpt (
	nodeID INTEGER NOT NULL,
	ckpt_execute_dir VARCHAR(1024), -- %kw=ckpt_execute_dir
	max_ckpt_interval INTEGER,  -- %kw=max_ckpt_interval
	min_ckpt_interval INTEGER,  -- %kw=min_ckpt_interval
	ckpt_cleanup_interval INTEGER, -- %kw=ckpt_cleanup_interval
	ckpt_cleanup_program VARCHAR(1024), -- %kw=ckpt_cleanup_program
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGSecurity ( 
	nodeID INTEGER NOT NULL,
	sec_admin_group	VARCHAR(80) BINARY, -- %kw=sec_admin_group
	sec_enablement CHAR(6), -- %kw=sec_enablement
	sec_services_group VARCHAR(80) BINARY, -- %kw=sec_services_group
	sec_imposed_mechs CHAR(4), -- %kw=sec_imposed_mechs
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;



CREATE TABLE TLLR_CFGDaemons (
	nodeID INTEGER NOT NULL,
	execute_dir VARCHAR(1024), -- %kw=execute
	spool_dir VARCHAR(1024),  -- %kw=spool
	job_epilog VARCHAR(1024), -- %kw=job_epilog
	job_user_epilog VARCHAR(1024), -- %kw=job_user_epilog
	job_prolog VARCHAR(1024), -- %kw=job_prolog
	job_user_prolog VARCHAR(1024), -- %kw=job_user_prolog
	start_daemons CHAR(5), -- %kw=start_daemons
	x_runs_here CHAR(5), -- %kw=x_runs_here
	polling_frequency INTEGER, -- %kw=polling_frequency
	polls_per_update INTEGER, -- %kw=polls_per_update
	update_on_poll_interval_only CHAR(5), -- %kw=update_on_poll_interval_only
	schedd_interval INTEGER, -- %kw=schedd_interval
	client_timeout INTEGER, -- %kw=client_timeout
	process_tracking CHAR(5), -- %kw=process_tracking
	process_tracking_extension VARCHAR(1024), -- %kw=process_tracking_extension
	log_message_threshold INTEGER, -- %kw=log_message_threshold
	obituary_log_length INTEGER, -- %kw=obituary_log_length
	publish_obituaries CHAR(5), -- %kw=publish_obituaries
	savelogs VARCHAR(1024), -- %kw=savelogs
	savelogs_compress_program VARCHAR(1024), -- %kw=savelogs_compress_program
	job_limit_policy INTEGER, -- %kw=job_limit_policy
	submit_filter VARCHAR(1024), -- %kw=submit_filter
	PRIMARY KEY (nodeID),
	FOREIGN KEY (nodeID) REFERENCES TLL_Nodelist (nodeID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGRMCluster ( 
	clusterID INTEGER NOT NULL,
	machine_authenticate CHAR(5), -- %kw=machine_authenticate
	resource_mgr_list VARCHAR(2560), -- decided not normalized because there is a ordering with this list -- %kw=resource_mgr_list
	afs_getnewtoken VARCHAR(1024), -- %kw=afs_getnewtoken
	dce_authentication_pair VARCHAR(1024), -- %kw=dce_authentication_pair
	reject_on_restricted_login CHAR(5), -- %kw=reject_on_restricted_login
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGRMClusterFloatingResources ( -- %kw=floating_resources
	clusterID INTEGER NOT NULL,
	name VARCHAR(80) NOT NULL, 
	resource_count INTEGER,
	PRIMARY KEY (clusterID, name),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGVipServerList ( -- %kw=vipserver_list
	clusterID INTEGER NOT NULL,
	vipserver VARCHAR(80) NOT NULL, 
	PRIMARY KEY (clusterID, vipserver),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE TLLR_CFGExternalScheduler ( 
	clusterID INTEGER NOT NULL,
	aggregate_adapters CHAR(3), -- %kw=aggregate_adapters
	wallclock_enforce CHAR(5), -- %kw=wallclock_enforce
	PRIMARY KEY (clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;

-- [7aq]: coefficients of cluster, gathered by initial program
CREATE TABLE IF NOT EXISTS TLLR_EnergyCoEfficients (
    frequency INTEGER NOT NULL,
	clusterID INTEGER NOT NULL,
    factor_a DOUBLE NOT NULL, 
    factor_b DOUBLE NOT NULL, 
    factor_c DOUBLE NOT NULL, 
    factor_d DOUBLE NOT NULL, 
    factor_e DOUBLE NOT NULL, 
    factor_f DOUBLE NOT NULL, 
    PRIMARY KEY (frequency, clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)
) ENGINE = InnoDB;

-- [7aq]: energy policy tag for jobs
CREATE TABLE IF NOT EXISTS TLLR_EnergyPolicyTag (
	energy_tag_name VARCHAR(256) NOT NULL,
	userid INTEGER NOT NULL,
	frequency INTEGER NOT NULL,
	clusterID INTEGER NOT NULL,
	job_step_id VARCHAR(280) NOT NULL,
	username VARCHAR(256) NOT NULL,
	last_used_time BIGINT NOT NULL,
	predict_power DOUBLE NOT NULL,
	energy_saving_pct DOUBLE NOT NULL,
	predict_elapse_time INTEGER NOT NULL,
	perf_degrad_pct DOUBLE NOT NULL,
    PRIMARY KEY (energy_tag_name, userid, frequency),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID)
) ENGINE = InnoDB;
