-- sccs_id = "@(#) src/ll/db/gen/mysql/ll_common_tables.sql, ll.db.gen, ll_rrnep2, rrnep21206a 1.16 5/27/11";
-- IBM_PROLOG_BEGIN_TAG 
-- This is an automatically generated prolog. 
--  
--  
--  
-- Licensed Materials - Property of IBM 
--  
-- Restricted Materials of IBM 
--  
-- (C) COPYRIGHT International Business Machines Corp. 2009,2011 
-- All Rights Reserved 
--  
-- US Government Users Restricted Rights - Use, duplication or 
-- disclosure restricted by GSA ADP Schedule Contract with IBM Corp. 
--  
-- IBM_PROLOG_END_TAG 

CREATE TABLE IF NOT EXISTS TLL_Cluster ( 
	clusterID INTEGER AUTO_INCREMENT,
	name VARCHAR(80) NOT NULL, -- %st=cluster %kw=label
	lastCFGMod INTEGER,
	lldbVersion CHAR(12),
	PRIMARY KEY (clusterID),
	UNIQUE (name)
) ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS TLL_MachineGroup ( 
	mgID INTEGER AUTO_INCREMENT,
	name VARCHAR(80) NOT NULL, -- %st=machine_group %kw=label
	clusterID INTEGER NOT NULL,
	PRIMARY KEY (mgID),
	UNIQUE(name, clusterID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID) ON DELETE CASCADE
) ENGINE = InnoDB;


CREATE TABLE IF NOT EXISTS TLL_Nodelist ( 
	nodeID INTEGER AUTO_INCREMENT,
	hostname VARCHAR(256) NOT NULL,
        clusterID INTEGER NOT NULL,
	mgID INTEGER,
        UNIQUE (hostname, clusterID),
        PRIMARY KEY (nodeID),
	FOREIGN KEY (clusterID) REFERENCES TLL_Cluster (clusterID),
	FOREIGN KEY (mgID) REFERENCES TLL_MachineGroup (mgID) ON DELETE SET NULL
) ENGINE = InnoDB;

CREATE TABLE TLL_RASLog (
	time_occurred BIGINT NOT NULL,
	time_logged BIGINT,
	event_id char(8) NOT NULL,
	node CHAR(80) NOT NULL,
	msg_type CHAR(1),
	message VARCHAR(1024),
	detail VARCHAR(1024),
	subject VARCHAR(280),
	reporter CHAR(128),
	tid INTEGER,
	function_name VARCHAR(256),
	line_number INTEGER,
	job_step_id VARCHAR(280),
	tag1 VARCHAR(30),
	tag2 VARCHAR(125),
	raw_data VARCHAR(4095),
	PRIMARY KEY(time_occurred, event_id, node)
) ENGINE = InnoDB;


CREATE VIEW VLL_Site
	AS SELECT `key` AS sKey, `value` AS sValue
        	FROM site;

CREATE VIEW VLL_Ppc
	AS SELECT `node` AS Node, `supernode` AS Supernode
		FROM ppc;
